/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : Robot suiveur de ligne
Version : 0
Date    : 03/12/2006
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Gnration des signaux IR
Test fait sur la carte SSI

Nom du programme : Tst_E_IR.c

Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>
#include <delay.h>


void main(void)
{
// Declare your local variables here
// type		nom		Commentaires
//--------------------------------------------------
unsigned char i;                // compteur de boucle (unsigned char =  octet)
unsigned char Cde_Del_IR;	// permet de multiplexer la commande des dels

// Port B initialization
// Func0=Out Func1=Out Func2=Out Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=0 State1=0 State2=0 State3=T State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x07;



while (1)
    {// dbut while
      	
      Cde_Del_IR = 1;
      
      for (i=0;i<3;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
       {// dbut du for
        PORTB = ~Cde_Del_IR; // ~ = opration NON sur les bits du mot
      	delay_us(?);       // delay_us(x) = sous-programme de temporisation de x s
      	PORTB = 0x3F;
        Cde_Del_IR = Cde_Del_IR << 1 ;    // << 1 =>  1 dcalage   gauche des bits dans le mot
        delay_us(?);
       }// fin du for 
       
       delay_us(?);   // Fin Acquisition de la position du robot par rapport  la ligne
      
    }// fin while;
}