;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATtiny26
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;Optimize for        : Speed
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 32 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Stay_On_Liine.vec"
	.INCLUDE "Stay_On_Liine.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : Robot suiveur de ligne Mr Line
;      10 Version : 1
;      11 Date    : 17/12/2006
;      12 Author  : Philippe Mariano                
;      13 Company : LYCEE Pierre Emile MARTIN       
;      14 Comments: Commande des Dels IR, rrecption et commande des
;      15 DELs correspondantes 
;      16 
;      17 Fichier : Stay_On_Line.c
;      18 Chip type           : ATtiny26
;      19 Clock frequency     : 8,000000 MHz
;      20 Memory model        : Tiny
;      21 External SRAM size  : 0
;      22 Data Stack size     : 32
;      23 *********************************************/
;      24 
;      25 #include <tiny26.h>
;      26 #include <delay.h>
;      27 
;      28 #define ACO 	ACSR.5      // Sortie du comparateur analogique      
;      29 
;      30 // Signaux de commande des moteurs
;      31 #define CDEMOTG	OCR1A        // Cde moteur Gauche
;      32 #define CDEMOTD	OCR1B	    // Cde moteur Droite
;      33 
;      34 // Rapport cyclique du signal de commande des moteurs
;      35 #define _40PC    150		// 40%
;      36 #define _50PC    125             // 50%
;      37 #define _60PC    100             // 60%
;      38 
;      39 // Prototype des fonctions
;      40 void Arret_Moteurs();
;      41 void Active_Timer();
;      42 
;      43 // Declare your global variables here  
;      44 // type		nom		Commentaires
;      45 //--------------------------------------------------
;      46 // Diffrentes commandes des moteurs
;      47 enum Etat_Commande_Moteur {CDE_ARRET,CDE_CENTRE1, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS} EtatCdeMot = CDE_ARRET;
;      48 // Diffrentes positions du robot par rapport  la ligne 
;      49 enum Etat_Position_Robot {HORS_LIGNE,DROITE_PLUS,CENTRE_2, DROITE, GAUCHE_PLUS,CENTRE_3, GAUCHE, CENTRE_1} Position_Robot = HORS_LIGNE; 
;      50 
;      51 // dbut prog principal
;      52 //---------------------
;      53 void main(void)
;      54 {

	.CSEG
_main:
;      55 
;      56 // Declare your local variables here
;      57 // type		nom		Commentaires
;      58 //--------------------------------------------------
;      59 unsigned char i;                // compteur de boucle
;      60 //unsigned char Position_Robot;   
;      61 unsigned char Cde_Del_IR;	// permet de multiplexer la commande des dels
;      62 
;      63  
;      64 // Input/Output Ports initialization
;      65 // Port A initialization
;      66 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=In Func7=In 
;      67 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=T State7=T 
;      68 PORTA=0x3F;
;	i -> R16
;	Cde_Del_IR -> R17
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      69 DDRA=0x3F;
	OUT  0x1A,R30
;      70 
;      71 // Timer/Counter 1 initialization
;      72 // Clock source: System Clock
;      73 // Clock value: 4000,000 kHz
;      74 // Mode: PWMA & B top=OCR1C
;      75 // OC1A output: Non-Inv., /OC1A connected
;      76 // OC1B output: Non-Inv., /OC1B connected
;      77 PLLCSR=0x00;
	CLR  R30
	OUT  0x29,R30
;      78 TCCR1A=0x53;
	LDI  R30,LOW(83)
	OUT  0x30,R30
;      79 TCCR1B=0x02;
	LDI  R30,LOW(2)
	OUT  0x2F,R30
;      80 TCNT1=0x00;
	CLR  R30
	OUT  0x2E,R30
;      81 OCR1A=0x00;
	OUT  0x2D,R30
;      82 OCR1B=0x00;
	OUT  0x2C,R30
;      83 OCR1C=0xff;    
	LDI  R30,LOW(255)
	OUT  0x2B,R30
;      84 
;      85 // Analog Comparator initialization
;      86 // Analog Comparator: On
;      87 ACSR=0x00;
	CLR  R30
	OUT  0x8,R30
;      88 
;      89 while (1)
_0x6:
;      90     {// dbut while (1)
;      91     
;      92 // Fonction acqurir
;      93 // ----------------------------------------------------------------------------------------     
;      94       Position_Robot = HORS_LIGNE; 	
	CLR  R5
;      95       Cde_Del_IR = 1; 
	LDI  R17,LOW(1)
;      96  
;      97       for (i=0;i<3;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
	LDI  R16,LOW(0)
_0xA:
	CPI  R16,3
	BRSH _0xB
;      98        {
;      99         PORTA = ~Cde_Del_IR;
	MOV  R30,R17
	COM  R30
	OUT  0x1B,R30
;     100       	delay_us(19);	//  ajuster 
	__DELAY_USB 51
;     101         if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
	SBIS 0x8,5
	RJMP _0xC
	OR   R5,R17
;     102         PORTA = 0x3F;
_0xC:
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     103         Cde_Del_IR = Cde_Del_IR << 1 ;
	LSL  R17
;     104         delay_us(540);	//  ajuster
	__DELAY_USW 1080
;     105        } 
	SUBI R16,-1
	RJMP _0xA
_0xB:
;     106        			// Fin Acquisition de la position du robot par rapport  la ligne
;     107 // ----------------------------------------------------------------------------------------
;     108        
;     109 // Dbut Traiter
;     110 // ----------------------------------------------------------------------------------------
;     111       switch (EtatCdeMot)              
	MOV  R30,R4
;     112        {                                   
;     113         case CDE_ARRET: Arret_Moteurs(); 
	CPI  R30,0
	BRNE _0x10
	RCALL _Arret_Moteurs
;     114         		if (Position_Robot == CENTRE_1)
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x11
;     115         		    { 
;     116         		      delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     117         		      Active_Timer();
	RCALL _Active_Timer
;     118         		      EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     119         		    }
;     120         		    else  EtatCdeMot = CDE_ARRET;
	RJMP _0x12
_0x11:
	CLR  R4
_0x12:
;     121         break;    
	RJMP _0xF
;     122         
;     123         case CDE_CENTRE1: CDEMOTG = _50PC; CDEMOTD = _50PC;
_0x10:
	CPI  R30,LOW(0x1)
	BRNE _0x13
	LDI  R30,LOW(125)
	OUT  0x2D,R30
	OUT  0x2C,R30
;     124                           if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x14
	LDI  R30,LOW(4)
	MOV  R4,R30
;     125                           	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x15
_0x14:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x16
	LDI  R30,LOW(6)
	RJMP _0x31
;     126                           		else EtatCdeMot = CDE_CENTRE1;
_0x16:
	LDI  R30,LOW(1)
_0x31:
	MOV  R4,R30
_0x15:
;     127         break;  
	RJMP _0xF
;     128         
;     129         case CDE_CENTRE2: EtatCdeMot = CDE_CENTRE1;   
_0x13:
	CPI  R30,LOW(0x2)
	BRNE _0x18
	LDI  R30,LOW(1)
	MOV  R4,R30
;     130         
;     131         break;   
	RJMP _0xF
;     132         
;     133         case CDE_CENTRE3: EtatCdeMot = CDE_CENTRE1;
_0x18:
	CPI  R30,LOW(0x3)
	BRNE _0x19
	LDI  R30,LOW(1)
	MOV  R4,R30
;     134         break; 
	RJMP _0xF
;     135         
;     136         case CDE_DROITE:CDEMOTG = _40PC; CDEMOTD = _50PC; 
_0x19:
	CPI  R30,LOW(0x4)
	BRNE _0x1A
	LDI  R30,LOW(150)
	OUT  0x2D,R30
	LDI  R30,LOW(125)
	OUT  0x2C,R30
;     137                          if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x1B
	LDI  R30,LOW(1)
	MOV  R4,R30
;     138                           	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
	RJMP _0x1C
_0x1B:
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x1D
	LDI  R30,LOW(5)
	RJMP _0x32
;     139                           		else EtatCdeMot = CDE_DROITE;
_0x1D:
	LDI  R30,LOW(4)
_0x32:
	MOV  R4,R30
_0x1C:
;     140         break;   
	RJMP _0xF
;     141         
;     142         case CDE_DROITE_PLUS:CDEMOTG = _40PC; CDEMOTD = _60PC;
_0x1A:
	CPI  R30,LOW(0x5)
	BRNE _0x1F
	LDI  R30,LOW(150)
	OUT  0x2D,R30
	LDI  R30,LOW(100)
	OUT  0x2C,R30
;     143                              if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x20
	LDI  R30,LOW(4)
	MOV  R4,R30
;     144                           	else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_ARRET;
	RJMP _0x21
_0x20:
	TST  R5
	BRNE _0x22
	CLR  R4
;     145                           		else EtatCdeMot = CDE_DROITE_PLUS;
	RJMP _0x23
_0x22:
	LDI  R30,LOW(5)
	MOV  R4,R30
_0x23:
_0x21:
;     146         break;  
	RJMP _0xF
;     147         
;     148         case CDE_GAUCHE: CDEMOTG = _50PC; CDEMOTD = _40PC;
_0x1F:
	CPI  R30,LOW(0x6)
	BRNE _0x24
	LDI  R30,LOW(125)
	OUT  0x2D,R30
	LDI  R30,LOW(150)
	OUT  0x2C,R30
;     149                          if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x25
	LDI  R30,LOW(1)
	MOV  R4,R30
;     150                           	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	RJMP _0x26
_0x25:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x27
	LDI  R30,LOW(7)
	RJMP _0x33
;     151                           		else EtatCdeMot = CDE_GAUCHE;
_0x27:
	LDI  R30,LOW(6)
_0x33:
	MOV  R4,R30
_0x26:
;     152         break;  
	RJMP _0xF
;     153         
;     154         case CDE_GAUCHE_PLUS: CDEMOTG = _60PC; CDEMOTD = _40PC;
_0x24:
	CPI  R30,LOW(0x7)
	BRNE _0xF
	LDI  R30,LOW(100)
	OUT  0x2D,R30
	LDI  R30,LOW(150)
	OUT  0x2C,R30
;     155         	              if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x2A
	LDI  R30,LOW(6)
	MOV  R4,R30
;     156                           	else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_ARRET;
	RJMP _0x2B
_0x2A:
	TST  R5
	BRNE _0x2C
	CLR  R4
;     157                           		else EtatCdeMot = CDE_GAUCHE_PLUS;
	RJMP _0x2D
_0x2C:
	LDI  R30,LOW(7)
	MOV  R4,R30
_0x2D:
_0x2B:
;     158         break;  
;     159        }             	// Fin Traiter
_0xF:
;     160 // ----------------------------------------------------------------------------------------  
;     161       delay_us(704); //  ajuster    
	__DELAY_USW 1408
;     162       		
;     163     }// fin while(1);
	RJMP _0x6
;     164 } // fin prog princ   
_0x2E:
	RJMP _0x2E
;     165 
;     166 // Sous-programmes
;     167 // ---------------------------------
;     168 void Arret_Moteurs()
;     169 {
_Arret_Moteurs:
;     170       TCCR1A = 0x00; // Arrt PWM 
	CLR  R30
	OUT  0x30,R30
;     171       TCCR1B = 0x00; 
	OUT  0x2F,R30
;     172       PORTB=0x0A;     // Arrt Moteur 
	LDI  R30,LOW(10)
	OUT  0x18,R30
;     173 } 
	RET
;     174 
;     175 void Active_Timer()
;     176 {
_Active_Timer:
;     177       TCCR1A=0x53;
	LDI  R30,LOW(83)
	OUT  0x30,R30
;     178       TCCR1B = 0x02;
	LDI  R30,LOW(2)
	OUT  0x2F,R30
;     179 } 
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

