;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATtiny26
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;Optimize for        : Speed
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 32 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Stay_On_Line.vec"
	.INCLUDE "Stay_On_Line.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : Robot suiveur de ligne Mr Line
;      10 Version : 1
;      11 Date    : 17/12/2006
;      12 Author  : Philippe Mariano                
;      13 Company : LYCEE Pierre Emile MARTIN       
;      14 Comments: Commande des Dels IR, rrecption et commande des
;      15 DELs correspondantes 
;      16 
;      17 Fichier : Stay_On_Line.c      
;      18 
;      19 Chip type           : ATtiny26
;      20 Clock frequency     : 8,000000 MHz
;      21 Memory model        : Tiny
;      22 External SRAM size  : 0
;      23 Data Stack size     : 32
;      24 *********************************************/
;      25 
;      26 #include <tiny26.h>
;      27 #include <delay.h>
;      28 
;      29 #define ACO 	ACSR.5      // Sortie du comparateur analogique      
;      30 
;      31 // Signaux de commande des moteurs
;      32 #define CDE_MOTD	OCR1A       // Cde moteur Droit
;      33 #define CDE_MOTG	OCR1B	    // Cde moteur Gauche
;      34 
;      35 // Rapport cyclique du signal de commande des moteurs  
;      36 #define _0PC	 255		 // 0%
;      37 #define _30PC    179		 // 30%
;      38 #define _40PC    153		 // 40%
;      39 #define _50PC    128             // 50%
;      40 #define _60PC    102             // 60%
;      41 
;      42 
;      43 // Prototype des fonctions
;      44 void Arret_Moteurs();
;      45 void Active_Timer();
;      46 
;      47 // Declare your global variables here  
;      48 // type		nom		Commentaires
;      49 //--------------------------------------------------
;      50 // Diffrentes commandes des moteurs
;      51 enum Etat_Commande_Moteur {DEPART,CDE_CENTRE1, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS} EtatCdeMot = DEPART;
;      52 // Diffrentes positions du robot par rapport  la ligne 
;      53 enum Etat_Position_Robot {HORS_LIGNE,DROITE_PLUS,CENTRE_2, DROITE, GAUCHE_PLUS,CENTRE_3, GAUCHE, CENTRE_1} Position_Robot = HORS_LIGNE; 
;      54 
;      55 //---------------------
;      56 // Dbut prog principal
;      57 //---------------------
;      58 void main(void)
;      59 {

	.CSEG
_main:
;      60 
;      61 // Declare your local variables here
;      62 // type		nom		Commentaires
;      63 //--------------------------------------------------
;      64 unsigned char i;                // compteur de boucle
;      65 //unsigned char Position_Robot;   
;      66 unsigned char Cde_Del_IR;	// permet de multiplexer la commande des dels
;      67 
;      68  
;      69 // Input/Output Ports initialization
;      70 // Port A initialization
;      71 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=In Func7=In 
;      72 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=T State7=T 
;      73 PORTA=0x3F;
;	i -> R16
;	Cde_Del_IR -> R17
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      74 DDRA=0x3F;
	OUT  0x1A,R30
;      75 
;      76 // Port B initialization
;      77 // Func0=In Func1=Out Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
;      78 // State0=T State1=0 State2=T State3=0 State4=T State5=T State6=T State7=T 
;      79 PORTB=0x00;
	CLR  R30
	OUT  0x18,R30
;      80 DDRB=0x0A;
	LDI  R30,LOW(10)
	OUT  0x17,R30
;      81 
;      82 // Timer/Counter 1 initialization
;      83 // Clock source: System Clock
;      84 // Clock value: 4000,000 kHz
;      85 // Mode: PWMA & B top=OCR1C
;      86 // OC1A output: Non-Inv., /OC1A connected
;      87 // OC1B output: Non-Inv., /OC1B connected
;      88 PLLCSR=0x00;
	CLR  R30
	OUT  0x29,R30
;      89 TCCR1A=0x53;
	LDI  R30,LOW(83)
	OUT  0x30,R30
;      90 TCCR1B=0x02;
	LDI  R30,LOW(2)
	OUT  0x2F,R30
;      91 TCNT1=0x00;
	CLR  R30
	OUT  0x2E,R30
;      92 OCR1A=0x00;
	OUT  0x2D,R30
;      93 OCR1B=0x00;
	OUT  0x2C,R30
;      94 OCR1C=0xff;    
	LDI  R30,LOW(255)
	OUT  0x2B,R30
;      95 
;      96 // Analog Comparator initialization
;      97 // Analog Comparator: On
;      98 ACSR=0x00;
	CLR  R30
	OUT  0x8,R30
;      99 
;     100       
;     101 
;     102 while (1)
_0x6:
;     103     {// dbut while (1)
;     104     
;     105 // Fonction acqurir
;     106 // ----------------------------------------------------------------------------------------     
;     107       Position_Robot = HORS_LIGNE; 	
	CLR  R5
;     108       Cde_Del_IR = 1; 
	LDI  R17,LOW(1)
;     109  
;     110       for (i=0;i<3;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
	LDI  R16,LOW(0)
_0xA:
	CPI  R16,3
	BRSH _0xB
;     111        {
;     112         PORTA = ~Cde_Del_IR;
	MOV  R30,R17
	COM  R30
	OUT  0x1B,R30
;     113       	delay_us(19);	//  ajuster 
	__DELAY_USB 51
;     114         if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
	SBIS 0x8,5
	RJMP _0xC
	OR   R5,R17
;     115         PORTA = 0x3F;
_0xC:
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     116         Cde_Del_IR = Cde_Del_IR << 1 ;
	LSL  R17
;     117         delay_us(540);	//  ajuster
	__DELAY_USW 1080
;     118        } 
	SUBI R16,-1
	RJMP _0xA
_0xB:
;     119        			// Fin Acquisition de la position du robot par rapport  la ligne
;     120 // ----------------------------------------------------------------------------------------
;     121 
;     122 // Position_Robot  	Commentaires                                                         
;     123 // 	0		Hors_Ligne          
;     124 // 	1		Droite +       
;     125 // 	2		Centre2 (CIR seul sur la ligne)       
;     126 // 	3 		Droite  	
;     127 // 	4		Gauche +     
;     128 // 	5		Centre3 (RIR LIR sur la ligne)       
;     129 // 	6		Gauche  
;     130 // 	7		Centre1 (3 Dels IR sur la ligne)   
;     131                  
;     132 // Visualisation des capteurs actifs
;     133 // -----------------------------------------------------------------------------------------
;     134 
;     135 switch (Position_Robot)              // Cde des Del     <- Capteur sur la ligne
	MOV  R30,R5
;     136        {                                   // DLG | DLC | DLR <- RIR | CIR | LIR
;     137         case 0: PORTA = 0b00111111; break; // off | off | off <-  n     n     n  // Hors ligne
	CPI  R30,0
	BRNE _0x10
	LDI  R30,LOW(63)
	OUT  0x1B,R30
	RJMP _0xF
;     138         case 1: PORTA = 0b00011111; break; // on  | off | off <-  n     n     o	 // Droite +
_0x10:
	CPI  R30,LOW(0x1)
	BRNE _0x11
	LDI  R30,LOW(31)
	OUT  0x1B,R30
	RJMP _0xF
;     139         case 2: PORTA = 0b00101111; break; // off | on  | off <-  n     o     n  // Centre 2
_0x11:
	CPI  R30,LOW(0x2)
	BRNE _0x12
	LDI  R30,LOW(47)
	OUT  0x1B,R30
	RJMP _0xF
;     140         case 3: PORTA = 0b00001111; break; // on  | on  | off <-  n     o     o  // Droite
_0x12:
	CPI  R30,LOW(0x3)
	BRNE _0x13
	LDI  R30,LOW(15)
	OUT  0x1B,R30
	RJMP _0xF
;     141         case 4: PORTA = 0b00110111; break; // off | off | on  <-  o     n     n  // Gauche +
_0x13:
	CPI  R30,LOW(0x4)
	BRNE _0x14
	LDI  R30,LOW(55)
	OUT  0x1B,R30
	RJMP _0xF
;     142         case 5: PORTA = 0b00111111; break; // off | off | off <-  o     n     o  // Centre 3
_0x14:
	CPI  R30,LOW(0x5)
	BRNE _0x15
	LDI  R30,LOW(63)
	OUT  0x1B,R30
	RJMP _0xF
;     143         case 6: PORTA = 0b00100111; break; // off | on  | on  <-  o     o     n  // Gauche
_0x15:
	CPI  R30,LOW(0x6)
	BRNE _0x16
	LDI  R30,LOW(39)
	OUT  0x1B,R30
	RJMP _0xF
;     144         case 7: PORTA = 0b00000111; break; // on  | on  | on  <-  o     o     o  // Centre 1
_0x16:
	CPI  R30,LOW(0x7)
	BRNE _0xF
	LDI  R30,LOW(7)
	OUT  0x1B,R30
;     145        }   
_0xF:
;     146 
;     147 // Fonction Traiter
;     148 // ----------------------------------------------------------------------------------------
;     149       
;     150       switch (EtatCdeMot)              
	MOV  R30,R4
;     151        { // Dbut switch (EtatCdeMot)                                 
;     152         case DEPART: Arret_Moteurs(); 
	CPI  R30,0
	BRNE _0x1B
	RCALL _Arret_Moteurs
;     153         		if ((Position_Robot == CENTRE_1)||(Position_Robot == CENTRE_2)||(Position_Robot == CENTRE_3))
	LDI  R30,LOW(7)
	CP   R30,R5
	BREQ _0x1D
	LDI  R30,LOW(2)
	CP   R30,R5
	BREQ _0x1D
	LDI  R30,LOW(5)
	CP   R30,R5
	BRNE _0x1C
_0x1D:
;     154         		    { 
;     155         		      delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     156         		      Active_Timer();
	RCALL _Active_Timer
;     157         		      EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     158         		    }
;     159         		    else  EtatCdeMot = DEPART;
	RJMP _0x1F
_0x1C:
	CLR  R4
_0x1F:
;     160         break;   
	RJMP _0x1A
;     161         
;     162         case CDE_CENTRE1: CDE_MOTG = _40PC; CDE_MOTD = _40PC;
_0x1B:
	CPI  R30,LOW(0x1)
	BRNE _0x20
	LDI  R30,LOW(153)
	OUT  0x2C,R30
	OUT  0x2D,R30
;     163                           if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x21
	LDI  R30,LOW(4)
	MOV  R4,R30
;     164                           	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x22
_0x21:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x23
	LDI  R30,LOW(6)
	RJMP _0x3F
;     165                           		else EtatCdeMot = CDE_CENTRE1;
_0x23:
	LDI  R30,LOW(1)
_0x3F:
	MOV  R4,R30
_0x22:
;     166         break;  
	RJMP _0x1A
;     167         
;     168         case CDE_CENTRE2: EtatCdeMot = CDE_CENTRE1;   
_0x20:
	CPI  R30,LOW(0x2)
	BRNE _0x25
	LDI  R30,LOW(1)
	MOV  R4,R30
;     169         
;     170         break;   
	RJMP _0x1A
;     171         
;     172         case CDE_CENTRE3: EtatCdeMot = CDE_CENTRE1;
_0x25:
	CPI  R30,LOW(0x3)
	BRNE _0x26
	LDI  R30,LOW(1)
	MOV  R4,R30
;     173         break; 
	RJMP _0x1A
;     174         
;     175         case CDE_DROITE:CDE_MOTG = _40PC; CDE_MOTD = _30PC; 
_0x26:
	CPI  R30,LOW(0x4)
	BRNE _0x27
	LDI  R30,LOW(153)
	OUT  0x2C,R30
	LDI  R30,LOW(179)
	OUT  0x2D,R30
;     176                          if (Position_Robot == CENTRE_2) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x28
	LDI  R30,LOW(1)
	MOV  R4,R30
;     177                           	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
	RJMP _0x29
_0x28:
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x2A
	LDI  R30,LOW(5)
	RJMP _0x40
;     178                           		else EtatCdeMot = CDE_DROITE;
_0x2A:
	LDI  R30,LOW(4)
_0x40:
	MOV  R4,R30
_0x29:
;     179         break;   
	RJMP _0x1A
;     180         
;     181         case CDE_DROITE_PLUS:CDE_MOTG = _50PC; CDE_MOTD = _30PC;
_0x27:
	CPI  R30,LOW(0x5)
	BRNE _0x2C
	LDI  R30,LOW(128)
	OUT  0x2C,R30
	LDI  R30,LOW(179)
	OUT  0x2D,R30
;     182         		if (Position_Robot == CENTRE_2) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x2D
	LDI  R30,LOW(1)
	MOV  R4,R30
;     183                              else if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	RJMP _0x2E
_0x2D:
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x2F
	LDI  R30,LOW(4)
	RJMP _0x41
;     184                               //	else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_ARRET;  terminer
;     185                           		else EtatCdeMot = CDE_DROITE_PLUS;
_0x2F:
	LDI  R30,LOW(5)
_0x41:
	MOV  R4,R30
_0x2E:
;     186         break;  
	RJMP _0x1A
;     187         
;     188         case CDE_GAUCHE: CDE_MOTG = _30PC; CDE_MOTD = _40PC; 
_0x2C:
	CPI  R30,LOW(0x6)
	BRNE _0x31
	LDI  R30,LOW(179)
	OUT  0x2C,R30
	LDI  R30,LOW(153)
	OUT  0x2D,R30
;     189                        if (Position_Robot == CENTRE_2) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x32
	LDI  R30,LOW(1)
	MOV  R4,R30
;     190                           	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	RJMP _0x33
_0x32:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x34
	LDI  R30,LOW(7)
	RJMP _0x42
;     191                           		else EtatCdeMot = CDE_GAUCHE;
_0x34:
	LDI  R30,LOW(6)
_0x42:
	MOV  R4,R30
_0x33:
;     192         break;  
	RJMP _0x1A
;     193         
;     194         case CDE_GAUCHE_PLUS: CDE_MOTG = _30PC; CDE_MOTD = _50PC; 
_0x31:
	CPI  R30,LOW(0x7)
	BRNE _0x3B
	LDI  R30,LOW(179)
	OUT  0x2C,R30
	LDI  R30,LOW(128)
	OUT  0x2D,R30
;     195                       if  (Position_Robot == CENTRE_2) EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x37
	LDI  R30,LOW(1)
	MOV  R4,R30
;     196         	              else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x38
_0x37:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x39
	LDI  R30,LOW(6)
	RJMP _0x43
;     197                                //	else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_ARRET;  terminer
;     198                           		else EtatCdeMot = CDE_GAUCHE_PLUS;
_0x39:
	LDI  R30,LOW(7)
_0x43:
	MOV  R4,R30
_0x38:
;     199         break; 
	RJMP _0x1A
;     200         
;     201         default : EtatCdeMot = CDE_CENTRE1; break;
_0x3B:
	LDI  R30,LOW(1)
	MOV  R4,R30
;     202          
;     203        }// Fin switch (EtatCdeMot)  
_0x1A:
;     204        
;     205 // ----------------------------------------------------------------------------------------  
;     206 // Fin Traiter
;     207        delay_us(704); //  ajuster    
	__DELAY_USW 1408
;     208       		
;     209     }// fin while(1);
	RJMP _0x6
;     210 } // fin prog princ   
_0x3C:
	RJMP _0x3C
;     211 
;     212 // Sous-programmes
;     213 // ---------------------------------
;     214 void Arret_Moteurs()
;     215 {
_Arret_Moteurs:
;     216       TCCR1A = 0x00; // Arrt PWM 
	CLR  R30
	OUT  0x30,R30
;     217       TCCR1B = 0x00; 
	OUT  0x2F,R30
;     218       PORTB=0x0A;     // Arrt Moteur 
	LDI  R30,LOW(10)
	OUT  0x18,R30
;     219 } 
	RET
;     220 
;     221 void Active_Timer()
;     222 {
_Active_Timer:
;     223       TCCR1A=0x53;
	LDI  R30,LOW(83)
	OUT  0x30,R30
;     224       TCCR1B = 0x02;
	LDI  R30,LOW(2)
	OUT  0x2F,R30
;     225 } 
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

